'''
Created on 2021. 7. 16.

@author: hahoeseong
'''
from graphcode.logging import *

import json
from os import path

from pathlib import Path

#source_path = Path(__file__).resolve()
#source_dir = source_path.parent

defaultConfigJsonFilename = "~/.graphcode/graphcode.conf"

defaultConfig_dict = {
  "DESKTOP-R5BM7GD": {"host": "0.0.0.0", "port": 5000, "debug": True, "ssl": True}, 
  "default": {"host": "0.0.0.0", "port": 443, "debug": True, "ssl": True}
}

def loadConfig(hostName = None, configJsonFilename = None):
  
  if configJsonFilename == None:
    configJsonFilename = defaultConfigJsonFilename
  logDebug("configJsonFilename:[{}]".format(path.abspath(configJsonFilename)))
  
  gcdConfig_dict = None
  try:
    f = open(configJsonFilename, "r")
    gcdConfig_dict = json.load(f)
    
    logDebug(gcdConfig_dict)
  except Exception as e:
    logException("Error:[{}]->Unable to load configJsonFilename:[{}]".format(e, configJsonFilename))
    
    if configJsonFilename != defaultConfigJsonFilename:
      try:
        gcdConfig_dict = loadConfig()
      except:
        gcdConfig_dict = defaultConfig_dict
    else:
      gcdConfig_dict = defaultConfig_dict
  
  try:
    return gcdConfig_dict[hostName]
  except:
    logException("unable to found '{}'".format(hostName))
    return gcdConfig_dict

def saveConfig(gcdConfig_dict, configJsonFilename = None):
  if configJsonFilename == None:
    configJsonFilename = defaultConfigJsonFilename
  logDebug("configJsonFilename:[{}]".format(path.abspath(configJsonFilename)))
  
  if isinstance(gcdConfig_dict, dict):
    try:
      logDebug("gcdConfig_dict:[{}]".format(gcdConfig_dict))
      f = open(configJsonFilename, "w")
      response = json.dump(gcdConfig_dict, f)
      
      
      logDebug(response)
      
      return True
    
    except Exception as e:
      logException("Error:[{}]->Unable to save configJsonFilename:[{}]".format(e, configJsonFilename))
      
      return False
  else:
    logDebug("type:dict is expected instead of [{}]".format(gcdConfig_dict))
    
    return False
  
  
    