'''
Created on 2021. 3. 21.

@author: hahoe
'''
from graphcode.logging import *

from os.path import dirname, expanduser, abspath, exists, basename
from os import mkdir

import platform
import shutil

def getOsDirPath(dirPath):
  if platform.system().startswith("Win"):
    return dirPath.replace("/","\\")
  else:
    return dirPath.replace("\\","/")

def getOsTempDir():
  if platform.system().startswith("Win"):
    return expanduser("~\AppData\Local\Temp")
  else:
    return expanduser("~/tmp")
      
def createDir(dirPath):
  if exists(expanduser(dirPath)):
    #print("dirPath:[{}] is already created".format(dirPath))
    
    return expanduser(dirPath)
  else:
    thisDirPath = ""
    
    if platform.system().startswith("Win"):
      for thisDirName in expanduser(getOsDirPath(dirPath)).split("\\"):
        if thisDirName.strip() != "":
          thisDirPath += thisDirName
          if exists(thisDirPath):
            pass
          else:
            mkdir(thisDirPath)
    else:
      for thisDirName in expanduser(getOsDirPath(dirPath)).split("/"):
        if thisDirName.strip() != "":
          thisDirPath += thisDirName
          if exists(thisDirPath):
            pass
          else:
            mkdir(thisDirPath)
    
    if thisDirPath != None:
      print("dirPath:[{}] is created".format(thisDirPath))
    
    return thisDirPath
  

def cloneDir(sourceDir, targetDir):
  
  sourceDir = expanduser(sourceDir)
  targetDir = expanduser(targetDir)
  logInfo("sourceDir:[{}]->targetDir:[{}]".format(sourceDir, targetDir))
  
  return shutil.copytree(sourceDir, targetDir) 
