'''
Created on 2021. 10. 3.

@author: hahoe
'''
import platform
import socket
import uuid
import psutil
import json
import re
from graphcode.logging import logException

def getSystemInfo():
  try:
      info={}
      info['platform']=platform.system()
      info['platform-release']=platform.release()
      info['platform-version']=platform.version()
      info['architecture']=platform.machine()
      info['hostname']=socket.gethostname()
      info['ip-address']=socket.gethostbyname(socket.gethostname())
      info['mac-address']=':'.join(re.findall('..', '%012x' % uuid.getnode()))
      info['processor']=platform.processor()
      info['ram']=str(round(psutil.virtual_memory().total / (1024.0 **3)))+" GB"
      return info
  except Exception as e:
      logException(e)
      
      return None